/*
  Melody
 
 Plays a melody 
 
 circuit:
 * 8-ohm speaker on digital pin 8
 
 created 21 Jan 2010
 by Tom Igoe 
 
 http://arduino.cc/en/Tutorial/Tone
 
 mod by SaTa.
 */
#include <avr/pgmspace.h>
#include <EEPROM.h>

#include "pz_data.h"
#include "pz_data2.h"
#include "pz_data3.h"
#include "pz_data4.h"
#include "pz_data5.h"
#include "pz_data6.h"
#include "pz.h"

#define LEDPIN 4     // どのピンからLEDをつなぐか
#define LEDPIN_MAX 10     // LED数
#define SWPIN 2      // スイッチをつなぐピン
#define SPKPIN 14      //  スピーカ

#define MAX_PZ (6)
int pz_no=0;
void pz_data_r(int i,unsigned char *a,unsigned char *b)
{
    switch(pz_no % MAX_PZ)
    {
      case 0:
        *a=(unsigned char)pgm_read_byte_near(pg_pz_data+i*2);
        *b=(unsigned char)pgm_read_byte_near(pg_pz_data+i*2+1);
        break;
      case 1:
        *a=(unsigned char)pgm_read_byte_near(pg_pz_data2+i*2);
        *b=(unsigned char)pgm_read_byte_near(pg_pz_data2+i*2+1);
        break;
      case 2:
        *a=(unsigned char)pgm_read_byte_near(pg_pz_data3+i*2);
        *b=(unsigned char)pgm_read_byte_near(pg_pz_data3+i*2+1);
        break;
      case 3:
        *a=(unsigned char)pgm_read_byte_near(pg_pz_data4+i*2);
        *b=(unsigned char)pgm_read_byte_near(pg_pz_data4+i*2+1);
        break;
      case 4:
        *a=(unsigned char)pgm_read_byte_near(pg_pz_data5+i*2);
        *b=(unsigned char)pgm_read_byte_near(pg_pz_data5+i*2+1);
        break;
      case 5:
        *a=(unsigned char)pgm_read_byte_near(pg_pz_data6+i*2);
        *b=(unsigned char)pgm_read_byte_near(pg_pz_data6+i*2+1);
        break;
    
    }
}

int ledPin=LEDPIN;
//int w=0;
int t=60;
float dt=0;
long i= 1;
long j=0;
//unsigned char *pz_data=pgm_read_word_near(pg_pz_data);
unsigned char a,b;

void setup() {
//テンポを計算する
//pz_data=pgm_read_word_near(pg_pz_data);
Serial.begin(9600); 

pinMode(SWPIN, INPUT);      // スイッチのピンを入力に
digitalWrite(SWPIN, HIGH);  // 内蔵プルアップ有効

for(j=0;j<LEDPIN_MAX;j++)
{
  pinMode(LEDPIN+j, OUTPUT);      // 出力に
}

// メモリ初期化

char flg=0;
char rt=0;
char data[4];
char MAGIC_CODE[5]="TMS0";

int val;
int v_max,v_min;

for(j=0;j<4;j++)
{
data[j] = EEPROM.read(j);
if(data[j]==MAGIC_CODE[j])flg++;
}



  if(flg<4)
  {
      for(j=0;j<4;j++)
      {
      EEPROM.write(j,MAGIC_CODE[j]) ;
      }
      EEPROM.write(4,1); 
  }
  else
  {
      rt=EEPROM.read(4);
      EEPROM.write(4,rt+1); 
  }




  if(rt%(MAX_PZ+1)==0)
  {
    tone(14, 880,500);
    delay(1000);

      //for(;;)
      {
         for(j=0;j<LEDPIN_MAX;j++)
         {
            digitalWrite(LEDPIN+j, HIGH);   // set the LED on
          delay(100);
         }
           
    
         for(j=0;j<LEDPIN_MAX;j++)
         {
            digitalWrite(LEDPIN+j, LOW);    // set the LED off
          delay(100);
          }

      }
      //
        int x=0,y,d_max,d_min;
        int v[20]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
        pinMode(SPKPIN, INPUT);
//        v_max = analogRead(SPKPIN);    // アナログピンを読み取る
//        v_min = v_max;
      for(;;)
      {
        v_max = analogRead(SPKPIN);    // アナログピンを読み取る
        v_min = v_max;
        for(y=0;y<5;y++)
        {
            val = analogRead(SPKPIN);    // アナログピンを読み取る
        //Serial.println(val);            // デバグ用に送信
          if (v_max < val) 
          {
              v_max=val;
          }
          if (v_min > val) 
          {
              v_min=val;
          }
          delay(10);
        }
        val=v_max;
      
        v[x]=val;
        
        d_min=d_max=val;
        for(y=0;y<20;y++)
        {

          if(d_max < v[y])d_max=v[y];
          if(d_min > v[y])d_min=v[y];
        }
        int pin;
        
        if(d_max-d_min <=0)
        {
          pin=0;
        }
          else
        { 
          pin=(LEDPIN_MAX * (val-d_min))/(d_max-d_min);
        }


         for(j=0;j<LEDPIN_MAX;j++)
         {
             if(  pin>j  )
             {
                digitalWrite(LEDPIN+LEDPIN_MAX-j-1, LOW);    // set the LED off
             }
             else
             {
                digitalWrite(LEDPIN+LEDPIN_MAX-j-1, HIGH);   // set the LED on
             }
          }

        
        x=(x+1)%20;
   //     delay(200);
   //     Serial.println(val);

      }

  }
  pz_no=(rt%(MAX_PZ+1))-1;

}

      int p=0;
      int vl=0;

void loop() {

  pz_data_r(0,&a,&b);
  t=a;
  
  dt=60000/t/48  ;  // 1clockの時間

  for (; ;i++) 
  {
    pz_data_r(i,&a,&b);
    if(a==0 && b==0)  {i=1;}
  
    for(j=0;j<LEDPIN_MAX;j++)
    {
      ledPin=LEDPIN+LEDPIN_MAX-j-1;
        if(a==0)
        {
        digitalWrite(ledPin, LOW);    // set the LED off
        }
        else
        {
        digitalWrite(ledPin, HIGH);   // set the LED on
        }
    }
    

    p =  b * dt;  // 音の長さ
     
//    if(digitalRead(SWPIN)==LOW)    // スイッチが入るとテンポアップ
//    {
//        p =  b * dt/4;  // 音の長さ
//    }

    tone(14, pz_hz[ a ],p);

#define VL (10)
vl=VL;
    for(j=0;j<LEDPIN_MAX;j++)
    {
         if(p-vl<=0)
         {
           
           break;
         }
          p=p-vl;

          delay(vl-1);
          vl=vl+vl;
          ledPin=LEDPIN+LEDPIN_MAX-j-1;
            digitalWrite(ledPin, LOW);    // set the LED off
    }


    delay(p);
    
//    for(j=0;j<7;j++)
//    {
//      ledPin=LEDPIN+j;
//        digitalWrite(ledPin, LOW);    // set the LED off
//    }
    


    
  }  

}




